package cn.superdesk.uniorder.controller.accounting.supplier;

import cn.superdesk.uniorder.common.json.AnJsonUtils;
import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dao.entity.accounting.unified.supplier.AccountingUnifiedSupplierXGoods;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.AccountingUnifiedSupplierXGoodsParam;
import cn.superdesk.uniorder.dubbo.consumer.accounting.supplier.AccountingUnifiedSupplierXGoodsDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2020-10-23 17:19:13
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020-10-23 17:19:13
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "[对账单]-供应商结算-对账单 X 商品 关联关系", tags = {"[对账单]-供应商结算-对账单 X 商品 关联关系"})
@Slf4j
@RestController
@RequestMapping("/accountingUnifiedSupplierXGoods")
public class AccountingUnifiedSupplierXGoodsController extends BaseController {

	@Autowired
	private AccountingUnifiedSupplierXGoodsDubboConsumerService accountingUnifiedSupplierXGoodsDubboConsumerService;

	@ApiOperation(value = "分页查询")
	@RequestMapping(value = "list", method = RequestMethod.POST)
	@ResponseBody
	public R<List<AccountingUnifiedSupplierXGoods>> pageQueryAccountingUnifiedSupplierXGoodss(@RequestBody PageQueryParam param) {

		log.info("pageQueryAccountingUnifiedSupplierXGoods:\n{}", AnJsonUtils.toJson(param));

		R<List<AccountingUnifiedSupplierXGoods>> result = new R<>();

		// TODO 参数合法性判定

		result = accountingUnifiedSupplierXGoodsDubboConsumerService.pageQuery(param.getConditions(), param.getPageNo(), param.getPageSize());

		return result;
	}

	@ApiOperation(value = "按id查询")
	@RequestMapping(value = "{id}", method = RequestMethod.GET)
	@ResponseBody
	public R<List<AccountingUnifiedSupplierXGoods>> getById(@PathVariable("id") long id) {

		R<List<AccountingUnifiedSupplierXGoods>> result = new R<>();

		// TODO 参数合法性判定

		AccountingUnifiedSupplierXGoods entity = accountingUnifiedSupplierXGoodsDubboConsumerService.findAccountingUnifiedSupplierXGoodsById(id);

		List<AccountingUnifiedSupplierXGoods> data = new ArrayList<>();
		data.add(entity);

		result.setData(data);

		return result;
	}

	@ApiOperation(value = "新增")
	@RequestMapping(value = "add", method = RequestMethod.POST)
	@ResponseBody
	public R<String> addAccountingUnifiedSupplierXGoods(@RequestBody AccountingUnifiedSupplierXGoodsParam param) {

		log.info("addAccountingUnifiedSupplierXGoods:\n{}", AnJsonUtils.toJson(param));


		// TODO 参数合法性判定

		accountingUnifiedSupplierXGoodsDubboConsumerService.addAccountingUnifiedSupplierXGoods(param);

		return new R<>("200", "操作成功", true);
	}

	@ApiOperation(value = "更新")
	@RequestMapping(value = "update", method = RequestMethod.POST)
	@ResponseBody
	public R<String> updateAccountingUnifiedSupplierXGoods(@RequestBody AccountingUnifiedSupplierXGoodsParam param) {

		log.info("updateAccountingUnifiedSupplierXGoods:\n{}", AnJsonUtils.toJson(param));

		accountingUnifiedSupplierXGoodsDubboConsumerService.updateAccountingUnifiedSupplierXGoods(param);

		return new R<>("200", "操作成功", true);
	}

	@ApiOperation(value = "删除")
	@RequestMapping(value = "delete/{id}", method = RequestMethod.POST)
	@ResponseBody
	public R<String> deleteAccountingUnifiedSupplierXGoods(@PathVariable("id") long id) {

		// TODO 参数合法性判定

		accountingUnifiedSupplierXGoodsDubboConsumerService.deleteAccountingUnifiedSupplierXGoods(id);

		return new R<>("200", "操作成功", true);
	}

	@ApiOperation(value = "批量删除")
	@RequestMapping(value = "delete_ids", method = RequestMethod.POST)
	@ResponseBody
	public R<String> deleteIdsAccountingUnifiedSupplierXGoods(@RequestParam(value = "ids") long[] ids) {

		log.info(AnJsonUtils.toJson(ids));

		for (long id : ids) {
			accountingUnifiedSupplierXGoodsDubboConsumerService.deleteAccountingUnifiedSupplierXGoods(id);
		}

		return new R<>("200", "操作成功", true);

	}


}
